(* renvoie la preuve si elle existe *)
type type_preuve = FAUX | but of char | hyplst of type_preuve list |
  buthypcpl of type_preuve * type_preuve;;

let regles = [[`a`;`b`;`c`];[`c`;`b`];[`b`];[`e`;`f`]];;

let print_regles r =
(* ecrit les regles sous la forme "hyp1 & hyp2 & hyp3 -> csq"
                                  "-> fait" *)
  let rec print_regle_rec q = match q with
    [] -> print_string "-> ";
    | t::q -> print_char t;
              if q = [] then print_char ` ` else print_string " & ";
	      print_regle_rec q
  in let print_regle r = match r with
    [] -> failwith "Erreur : regle vide"
    | t::q -> print_char ` `;
              print_regle_rec q;
              print_char t;
              print_char `\n`
  in let rec print_regles_rec r = match r with
    [] -> print_char `\n`
    | t::q -> print_regle t;
              print_regles_rec q
  in print_string "Les rgles sont :\n";
     print_regles_rec r;
     flush std_out
;;

let rec print_preuve p = match p with
(* ecrit la preuve p sous la forme 
   (h1 & (h3 -> h2) -> b) avec
   b est le but, h1 et h2 sont les hypotheses de ce but,
   avec -> h1 et h3 -> h2   *)
  FAUX -> failwith "Erreur : il y a un FAUX dans la preuve" (* impossible *)
  | but b -> print_char b                     (* affiche le but courant *)
  | buthypcpl (a,hyplst []) -> print_preuve a (* a est un fait *)
  | buthypcpl (a,b) -> print_char `(`;        (* affiche (b -> a) *)
                       print_preuve b;
                       print_string " -> ";
                       print_preuve a;
                       print_char `)`
  | hyplst (t::q) -> print_preuve t;
                     if q <> [] then (print_string " & ";
                     print_preuve (hyplst q))
  | _ -> failwith "cas normallement inaccessible dans print_preuve"
;;

let rec prouvebut r rtot b = match r with
(* si le but b est demontrable renvoie buthypcpl (b,prouvelist hypotheses)
   sinon renvoie FAUX *)
  [] -> FAUX                        (* aucune regle n'a convenu *)
  | t::q -> match t with
    [] -> failwith "Erreur : regle vide"
    | t2::q2 -> if t2 = b then      (* si b est la ccl de l'hyp en cours *)
      let x = prouvelist rtot q2 in
        if x = FAUX then prouvebut q rtot b (* ses hyp sont indmontrables *)
          else buthypcpl (but b,x)  (* b est prouv *)
      else prouvebut q rtot b       (* essaye la regle suivante *)
and prouvelist r l = match l with
(* si chaque element de la liste est demontrable revoie hyplst (prouvebut)
   sinon renvoie FAUX *)
  [] -> hyplst []
  | t::q -> (let x = prouvebut r r t in
                     if x = FAUX then FAUX
                       else match prouvelist r q with
                         FAUX -> FAUX       (* propagation du faux *)
                         | hyplst yy -> hyplst (x::yy)
                         | _ -> failwith "Mauvais type renvoy par prouvelist"
            )
;;

print_regles regles;
print_string "Quel but voulez-vous tester ?\n";
flush std_out;
let x = (prouvebut regles regles (input_char std_in)) in
match x with 
  FAUX -> print_string "Le but est indmontrable\n"
  | _ -> print_string "Le but est est vrai. La preuve : \n";
         print_preuve x;
         print_char `\n`
;;
exit 0;;
