(* donne toutes les preuves *)
type type_preuve = FAUX | but of char | autrepreuve of type_preuve list |
  hyplst of type_preuve list | buthypcpl of type_preuve * type_preuve
;;

let regles = [[`a`;`b`;`c`];[`c`;`b`];[`b`];[`e`;`f`];[`a`];[`c`]];;

let print_regles r =
(* ecrit les regles sous la forme "hyp1 & hyp2 & hyp3 -> csq"
                                  "-> fait" *)
  let rec print_regle_rec q = match q with
    [] -> print_string "-> ";
    | t::q -> print_char t;
              if q = [] then print_char ` ` else print_string " & ";
	      print_regle_rec q
  in let print_regle r = match r with
    [] -> failwith "Erreur : regle vide"
    | t::q -> print_char ` `;
              print_regle_rec q;
              print_char t;
              print_char `\n`
  in let rec print_regles_rec r = match r with
    [] -> print_char `\n`
    | t::q -> print_regle t;
              print_regles_rec q
  in print_string "Les rgles sont :\n";
     print_regles_rec r;
     flush std_out
;;

let rec print_preuve p = match p with
(* ecrit la preuve p sous la forme 
   (((hyp1 -> hyp2) -> hyp3) ou (hyp1 -> hyp3)) -> but
   avec hyp1 fait et hyp1 -> hyp2 et hyp1 -> hyp3 et hyp2 -> hyp3 et hyp3 -> but
*)
  but b -> print_char b
  | buthypcpl (a, hyplst []) -> print_preuve a        (* "a" (fait) *)
  | buthypcpl (a, hyplst [b]) -> print_char `(`;      (* "(b -> a)" *)
                                 print_preuve b;
                                 print_string " -> ";
                                 print_preuve a;
                                 print_char `)`
  | buthypcpl (a,b) -> print_string "((";             (* "((hyplst b) -> a)" *)
                       print_preuve b;
                       print_string ") -> ";
                       print_preuve a;
                       print_string ")"
  | hyplst (t::q) -> print_preuve t;                  (* "b1 & b2 & b3" *)
                     if q <> [] then (print_string " & ";
                                      print_preuve (hyplst q)
                                     )
  | autrepreuve (t::q) -> print_preuve t;             (* "b1 ou b2 ou b3" *)
                          if q <> [] then (print_string " ou ";
                                           print_preuve (autrepreuve q)
                                          )
  | _ -> failwith "Cas inaccessible 1"
;;

let rec prouvebutexhaust r rtot b = match r with
(* renvoie la liste des dmonstrations de b ou FAUX *)
  [] -> FAUX                         (* toutes les regles ont t testes *)
  | t::q -> match t with
    [] -> failwith "Erreur : regle vide"
    | t2::q2 -> if t2 = b then       (* si b est la ccl de l'hyp en cours *)
      (let x = prouvelist rtot q2 in
        if x = FAUX then prouvebutexhaust q rtot b (* si les hyp sont fausses *)
          else match prouvebutexhaust q rtot b with 
	    FAUX -> autrepreuve [buthypcpl (but b,x)] (* si c'est la derniere preuve de b renvoie le singleton *)
	    | autrepreuve l -> autrepreuve ((buthypcpl (but b,x))::l) (* sinon rajoute cette preuve a la liste *)
	    | _ -> failwith "Cas inaccessible 2"
      )
      else prouvebutexhaust q rtot b (* teste la regle suivante *)
and prouvelist r l = match l with
(* si chaque element de la liste est demontrable revoie hyplst (prouvebut)
   sinon renvoie FAUX *)
  [] -> hyplst []
  | t::q -> (let x = prouvebutexhaust r r t in
                     if x = FAUX then FAUX
                       else match prouvelist r q with
                         FAUX -> FAUX       (* propagation du faux *)
                         | hyplst yy -> hyplst (x::yy)
                         | _ -> failwith "Cas inaccessible 3"
            )
;;

print_regles regles;;
print_string "Quel but voulez-vous tester ?\n";
flush std_out;;
let x = (prouvebutexhaust regles regles (input_char std_in)) in
match x with 
  FAUX -> print_string "Le but est indmontrable\n"
  | _ -> print_string "Le but est est vrai. Les preuves : \n";
         print_preuve x;
         print_char `\n`
;;
exit 0;;
