(* donne toutes les preuves, anti-bouclage *)
type type_preuve = FAUX | but of char | autrepreuve of type_preuve list |
  hyplst of type_preuve list | buthypcpl of type_preuve * type_preuve
;;

let regles = [[`b`];[`f`;`e`];[`a`;`b`];[`b`;`a`];[`e`;`f`]];;

let print_regles r =
(* ecrit les regles sous la forme "hyp1 & hyp2 & hyp3 -> csq"
                                  "-> fait" *)
  let rec print_regle_rec q = match q with
    [] -> print_string "-> ";
    | t::q -> print_char t;
              if q = [] then print_char ` ` else print_string " & ";
	      print_regle_rec q
  in let print_regle r = match r with
    [] -> failwith "Erreur : regle vide"
    | t::q -> print_char ` `;
              print_regle_rec q;
              print_char t;
              print_char `\n`
  in let rec print_regles_rec r = match r with
    [] -> print_char `\n`
    | t::q -> print_regle t;
              print_regles_rec q
  in print_string "Les rgles sont :\n";
     print_regles_rec r;
     flush std_out
;;

let rec print_preuve p = match p with
(* ecrit la preuve p sous la forme 
   (((hyp1 -> hyp2) -> hyp3) ou (hyp1 -> hyp3)) -> but
   avec hyp1 fait et hyp1 -> hyp2 et hyp1 -> hyp3 et hyp2 -> hyp3 et hyp3 -> but
*)
  but b -> print_char b
  | buthypcpl (a, hyplst []) -> print_preuve a        (* "a" *)
  | buthypcpl (a, hyplst [b]) -> print_char `(`;      (* "(b -> a)" *)
                                 print_preuve b;
                                 print_string " -> ";
                                 print_preuve a;
                                 print_char `)`
  | buthypcpl (a,b) -> print_string "((";             (* "((hyplst b) -> a)" *)
                       print_preuve b;
                       print_string ") -> ";
                       print_preuve a;
                       print_string ")"
  | hyplst (t::q) -> print_preuve t;                  (* "b1 & b2 & b3" *)
                     if q <> [] then (print_string " & ";
                                      print_preuve (hyplst q)
                                     )
  | autrepreuve (t::q) -> print_preuve t;             (* "b1 ou b2 ou b3" *)
                          if q <> [] then (print_string " ou ";
                                           print_preuve (autrepreuve q)
                                          )
  | _ -> failwith "Preuve non prvue dans le match"
;;

let rec inlist e l = match l with
(* renvoie true si e est dans la liste l *)
  [] -> false
  | t::q -> if t = e then true else inlist e q
;;

let rec prouvebutexhaust r rtot b bencours = match r with
(* renvoie la liste des dmonstrations de b ou FAUX *)
  [] -> FAUX
  | t::q -> match t with
    [] -> failwith "Erreur : regle vide"
    | t2::q2 -> if t2 = b then
      (let x = prouvelist rtot q2 (b::bencours) in
        if x = FAUX then prouvebutexhaust q rtot b bencours
          else match prouvebutexhaust q rtot b bencours with 
	    FAUX -> autrepreuve [buthypcpl (but b,x)]
	    | autrepreuve l -> autrepreuve ((buthypcpl (but b,x))::l)
	    | _ -> failwith "Mauvais type renvoy par prouvebutexhaust"
      )
      else prouvebutexhaust q rtot b bencours
and prouvelist r l bencours = match l with
(* si chaque element de la liste est demontrable revoie hyplst (prouvebut)
   sinon renvoie FAUX *)
  [] -> hyplst []
  | t::q -> if inlist t bencours then FAUX (* anti-bouclage *)
              else (let x = prouvebutexhaust r r t bencours in
                     if x = FAUX then FAUX
                       else match prouvelist r q (t::bencours) with
                         FAUX -> FAUX       (* propagation du faux *)
                         | hyplst yy -> hyplst (x::yy)
                         | _ -> failwith "Mauvais type renvoy par prouvelist"
                   )
;;

print_regles regles;;
print_string "Quel but voulez-vous tester ?\n";
flush std_out;;
let x = (prouvebutexhaust regles regles (input_char std_in) [] ) in
match x with 
  FAUX -> print_string "Le but est indmontrable\n"
  | _ -> print_string "Le but est est vrai. Les preuves : \n";
         print_preuve x;
         print_char `\n`
;;
exit 0;;
